Attribute VB_Name = "SetHalfTransparency"
Private oProductDocument As ProductDocument
Private oPartDocument As PartDocument
Private rootObject As Product
Private oSelection As Selection
Private typeDoc As Variant
Private typeObj As Variant
Private oUpPart As Part
Private oMainBody As Body
Private oPartObject As Part

Sub CATMain()

    If CheckTreeDocument Then
        SetOpacity
    End If

End Sub

Public Function SetOpacity()
Dim op, i, lngInherit, lngInheritProb, enumStatus As Variant
Dim Feature, oLeafProduct, LeafProductProcessed
Dim oCollectionFeature As New Collection
Dim oCollectionLeafProduct As New Collection
Dim AutomationTreeNodeOrProduct
Dim cText, nCnt, nCntSelect
Dim lSetInheritance, lOpacity As Boolean
Dim specsAndGeomWindow1 As SpecsAndGeomWindow
Dim viewer3D1 As Viewer3D
Dim viewpoint3D1 As Viewpoint3D
Dim oCurMaterial As Material
Dim oMainBody As Body

    Set specsAndGeomWindow1 = CATIA.ActiveWindow
    Set viewer3D1 = specsAndGeomWindow1.ActiveViewer
    Set viewpoint3D1 = viewer3D1.Viewpoint3D
    lOpacity = False
    On Error Resume Next
    op = CLng(0)
    lngInheritProb = CLng(0)
    lngInherit = CLng(-1)
    enumStatus = CLng(0)
    nCntSelect = oSelection.Count
    Set oCollectionFeature = Nothing
    For i = 1 To nCntSelect
        oCollectionFeature.Add oSelection.Item(i)
        oCollectionLeafProduct.Add oSelection.Item(i).LeafProduct
    Next
    
    
    Set Feature = oSelection.Item(1).Value
    nCnt = 1
    lSetInheritance = True
    Set oLeafProduct = oSelection.Item(1).LeafProduct
    LeafProductProcessed = True
    If (oLeafProduct.Name <> "InvalidLeafProduct") Then
        LeafProductProcessed = False
    End If
    
    Set AutomationTreeNodeOrProduct = Feature
    Do While (TypeName(AutomationTreeNodeOrProduct) <> "Application")
        If ((TypeName(AutomationTreeNodeOrProduct) <> "Shapes") And _
            (TypeName(AutomationTreeNodeOrProduct) <> "Bodies") And _
            (TypeName(AutomationTreeNodeOrProduct) <> "PartDocument") And _
            (TypeName(AutomationTreeNodeOrProduct) <> "ProductDocument")) Then
            If nCnt = 1 Then
                ' Retrive Opacity of selected object
                Set VisProperties = oSelection.VisProperties
                op = CLng(0)
                VisProperties.GetVisibleOpacity op
                ' Set Opacity of selected object
                If op <> 255 Then
                    ' Opacity = 0, Inheritance enabled
                    '
                    VisProperties.SetRealOpacity 255, 1
                    lOpacity = False
                Else
                    ' Opacity = 55, Inheritance enabled
                    '
                    VisProperties.SetRealOpacity 55, 1
                    lOpacity = True
                End If
                If TypeName(AutomationTreeNodeOrProduct) = "Product" Then
                    ' Don't disable Inheritance on next loop's
                    lSetInheritance = False
                End If
            Else
                ' Set Inheritance of up objects
                'If lSetInheritance Then
                    oSelection.Clear
                    oSelection.Add AutomationTreeNodeOrProduct
                    Set VisProperties = oSelection.VisProperties
                    enumStatus = VisProperties.GetVisibleInheritance(3, lngInheritProb)
                    If enumStatus = 0 Then 'Inheritance is support!!!
                        If lngInherit < 0 Then
                            If lngInheritProb = 0 Then
                                lngInherit = 1
                            Else
                                lngInherit = 0
                            End If
                            VisProperties.SetRealOpacity 255, lngInherit
                        Else
                            VisProperties.SetRealOpacity 255, lngInherit
                        End If
                        'If lngInheritProb = 1 Then 'Inheritance is ON?
                            'Set Inheritance = OFF, Opacity = 0
                        '    VisProperties.SetRealOpacity 255, 0
                        'Else
                        '    VisProperties.SetRealOpacity 255, 1
                        'End If
                        'lOpacity = False
                    End If
                'End If
            End If
        End If
        ' We determine the next automation tree node or product
        Set AutomationTreeNodeOrProduct = AutomationTreeNodeOrProduct.Parent
        
        If ((TypeName(AutomationTreeNodeOrProduct) = "Application") And (Not LeafProductProcessed)) Then
            Set AutomationTreeNodeOrProduct = oLeafProduct
            LeafProductProcessed = True
        End If
        nCnt = nCnt + 1
        If ((TypeName(AutomationTreeNodeOrProduct) = "SiTransiantObject")) Then
            Exit Do
        End If
        If ((TypeName(AutomationTreeNodeOrProduct) = "Empty")) Then
            Exit Do
        End If
        If ((TypeName(AutomationTreeNodeOrProduct) = "HybridShapes")) Then
            Exit Do
        End If
        If ((TypeName(AutomationTreeNodeOrProduct) = "Reference")) Then
            Exit Do
        End If
    Loop
    Set oManager = oPartObject.GetItem("CATMatManagerVBExt")
    oManager.GetMaterialOnPart oPartObject, oCurMaterial
    If TypeName(oCurMaterial) = "Material" Then
        If oCurMaterial.RenderingMaterial.TransparencyCoefficient <> 0 Then
            If Not lOpacity Then
                oCurMaterial.RenderingMaterial.TransparencyCoefficient = 0
            End If
        Else
            If lOpacity Then
                oCurMaterial.RenderingMaterial.TransparencyCoefficient = 0.6
            End If
        End If
        oManager.ApplyMaterialOnPart oPartObject, oCurMaterial, 1
    End If
    oSelection.Clear
    oPartObject.Update
    oSelection.Add Feature
    On Error GoTo 0
End Function

    
Public Function CheckTreeDocument()
Dim typeDoc As Variant
Dim oObject, oCurObject As AnyObject

    CheckTreeDocument = False
    On Error GoTo SkipCode
    typeDoc = TypeName(CATIA.ActiveDocument)
    Select Case typeDoc
        Case "ProductDocument"
            Set oProductDocument = CATIA.ActiveDocument
            Set oSelection = oProductDocument.Selection
            Set rootObject = oProductDocument.Product
            Set oCurObject = oSelection.Item(1).Value
            Do While (TypeName(oCurObject) <> "Part")
                Set oCurObject = oCurObject.Parent
                Select Case TypeName(oCurObject)
                    Case "Part"
                        Set oPartObject = oCurObject
                        Set oMainBody = oCurObject.MainBody
                        CheckTreeDocument = True
                    Case "PartDocument"
                        Set oPartObject = oCurObject.Part
                        Set oMainBody = oPartObject.MainBody
                        CheckTreeDocument = True
                    Case "Application"
                        GoTo SkipCode
                End Select
            Loop
            
        Case "PartDocument"
            Set oPartDocument = CATIA.ActiveDocument
            Set oSelection = oPartDocument.Selection
            Set rootObject = oPartDocument.Product
            Set oCurObject = oSelection.Item(1).Value
            Do While (TypeName(oCurObject) <> "Part")
                Set oCurObject = oCurObject.Parent
                Select Case TypeName(oCurObject)
                    Case "Part"
                        Set oPartObject = oCurObject
                        Set oMainBody = oCurObject.MainBody
                        CheckTreeDocument = True
                    Case "PartDocument"
                        Set oPartObject = oCurObject.Part
                        Set oMainBody = oPartObject.MainBody
                        CheckTreeDocument = True
                    Case "Application"
                        GoTo SkipCode
                End Select
                
            Loop
 
    End Select
    '
    CheckTreeDocument = True
        
SkipCode:

    On Error GoTo 0
    
End Function
